# -*- coding: utf-8 -*-
# Generated by Django 1.11.5 on 2018-06-10 01:59
from __future__ import unicode_literals

import collections
from django.db import migrations, models
import django.db.models.deletion
import jsonfield.fields
import party.models.base


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Combat',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('positions', party.models.base.ListField(blank=True, null=True)),
            ],
            options={
                'get_latest_by': 'pk',
            },
        ),
        migrations.CreateModel(
            name='Combatant',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=256)),
                ('initiative', models.IntegerField(help_text='Stores current initiative roll', null=True)),
                ('is_ready', models.BooleanField(default=False, help_text='Indicates character holding an action')),
                ('ready_reason', models.TextField(blank=True, default=None, help_text='Optional reason for holding an action, for display purposes', null=True)),
                ('combat', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='combatants', to='party.Combat')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Creature',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=256)),
                ('type', models.CharField(choices=[('PC', 'PC'), ('NPC', 'NPC'), ('monster', 'monster')], max_length=7)),
                ('stats', jsonfield.fields.JSONField(default=collections.OrderedDict, help_text='Mapping of skill/ability name to score')),
                ('base_effects', jsonfield.fields.JSONField(default=list, help_text='List of effects creature starts most fights with.')),
                ('max_hit_points', models.IntegerField(blank=True, null=True)),
                ('level', models.IntegerField(default=1)),
                ('previous_stats', jsonfield.fields.JSONField(default=collections.OrderedDict, help_text='Backup of stats at previous level, for lazy failover')),
            ],
        ),
        migrations.CreateModel(
            name='Edition',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=32)),
                ('is_official', models.BooleanField(default=True)),
                ('default_stats', jsonfield.fields.JSONField(default=dict)),
            ],
        ),
        migrations.CreateModel(
            name='Game',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=256, unique=True)),
                ('description', models.TextField()),
            ],
            options={
                'get_latest_by': 'pk',
            },
        ),
        migrations.CreateModel(
            name='Party',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('name', models.CharField(max_length=256, unique=True)),
                ('game', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='party.Game')),
            ],
            options={
                'get_latest_by': 'updated_at',
            },
        ),
        migrations.AddField(
            model_name='creature',
            name='game',
            field=models.ForeignKey(help_text='Game this creature belongs to; None if universal, but PCs should never be universal.', null=True, on_delete=django.db.models.deletion.CASCADE, to='party.Game'),
        ),
        migrations.AddField(
            model_name='creature',
            name='party',
            field=models.ForeignKey(help_text='Party this creature belongs to, if PC or NPC', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='members', to='party.Party'),
        ),
        migrations.AddField(
            model_name='combatant',
            name='creature',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='characters', to='party.Creature'),
        ),
        migrations.AddField(
            model_name='combat',
            name='current_turn',
            field=models.ForeignKey(default=None, help_text='Combatant whose turn it is.', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to='party.Combatant'),
        ),
        migrations.AddField(
            model_name='combat',
            name='game',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='party.Game'),
        ),
        migrations.AddField(
            model_name='combat',
            name='participants',
            field=models.ManyToManyField(through='party.Combatant', to='party.Creature'),
        ),
        migrations.AlterUniqueTogether(
            name='creature',
            unique_together=set([('name', 'type', 'game')]),
        ),
    ]
